function y = cmy2ycc(fname,pmodel)
% it is actually rgb2ycc because fname should be rgb (255-cmy) halftone image
x = imread(fname);

x = x(5:end-4,5:end-4,:);

x = 255-x; %rgb to cmy
[rows,cols,ch] = size(x);
y = zeros(size(x));

lut = readlut(pmodel);

parfor r = 1:rows,
    for c = 1:cols,
        v1 = x(r,c,1); v2 = x(r,c,2); v3 = x(r,c,3);
        if (v1<0.5 && v2<0.5 && v3<0.5) ind1 = 0;
        elseif (v1>0.5 && v2<0.5 && v3<0.5) ind1 = 1;
        elseif (v1<0.5 && v2>0.5 && v3<0.5) ind1 = 2;
        elseif (v1<0.5 && v2<0.5 && v3>0.5) ind1 = 3;
        elseif (v1>0.5 && v2>0.5 && v3<0.5) ind1 = 4;
        elseif (v1>0.5 && v2<0.5 && v3>0.5) ind1 = 5;
        elseif (v1<0.5 && v2>0.5 && v3>0.5) ind1 = 6;
        else ind1 = 7;
        end
        if (c<cols),
            v1 = x(r,c+1,1); v2 = x(r,c+1,2); v3 = x(r,c+1,3);
        else v1=0;v2=0;v3=0;
        end
        if (v1<0.5 && v2<0.5 && v3<0.5) ind2 = 0;
        elseif (v1>0.5 && v2<0.5 && v3<0.5) ind2 = 1;
        elseif (v1<0.5 && v2>0.5 && v3<0.5) ind2 = 2;
        elseif (v1<0.5 && v2<0.5 && v3>0.5) ind2 = 3;
        elseif (v1>0.5 && v2>0.5 && v3<0.5) ind2 = 4;
        elseif (v1>0.5 && v2<0.5 && v3>0.5) ind2 = 5;
        elseif (v1<0.5 && v2>0.5 && v3>0.5) ind2 = 6;
        else ind2 = 7;
        end
        if ((r<rows)&&(c<cols)),
            v1 = x(r+1,c+1,1); v2 = x(r+1,c+1,2); v3 = x(r+1,c+1,3);
        else v1=0;v2=0;v3=0;
        end
        if (v1<0.5 && v2<0.5 && v3<0.5) ind3 = 0;
        elseif (v1>0.5 && v2<0.5 && v3<0.5) ind3 = 1;
        elseif (v1<0.5 && v2>0.5 && v3<0.5) ind3 = 2;
        elseif (v1<0.5 && v2<0.5 && v3>0.5) ind3 = 3;
        elseif (v1>0.5 && v2>0.5 && v3<0.5) ind3 = 4;
        elseif (v1>0.5 && v2<0.5 && v3>0.5) ind3 = 5;
        elseif (v1<0.5 && v2>0.5 && v3>0.5) ind3 = 6;
        else ind3 = 7;
        end
        if (r<rows),
            v1 = x(r+1,c,1); v2 = x(r+1,c,2); v3 = x(r+1,c,3);
        else v1=0;v2=0;v3=0;
        end
        if (v1<0.5 && v2<0.5 && v3<0.5) ind4 = 0;
        elseif (v1>0.5 && v2<0.5 && v3<0.5) ind4 = 1;
        elseif (v1<0.5 && v2>0.5 && v3<0.5) ind4 = 2;
        elseif (v1<0.5 && v2<0.5 && v3>0.5) ind4 = 3;
        elseif (v1>0.5 && v2>0.5 && v3<0.5) ind4 = 4;
        elseif (v1>0.5 && v2<0.5 && v3>0.5) ind4 = 5;
        elseif (v1<0.5 && v2>0.5 && v3>0.5) ind4 = 6;
        else ind4 = 7;
        end
        
        ind = 8*8*8*ind1 + 8*8*ind2 + 8*ind3 + ind4 + 1;
        y(r,c,:) = lut(:,ind);
    end
end