function [Xpc1, Xpc2, Xpc3] = trainPCAold(x, N)

rx = size(x,1);
cx = size(x,2);
Nr = floor(rx/N);
Nc = floor(cx/N);
Nf = 0;
temps = Nr*Nc;

S1 = 0; S2 = 0;
if N==32, Nf = 21; S1 = 7; S2 = 5; end
res = zeros(Nf,Nf,temps);
ind = 0;

mask = ones(Nf,Nf);
mask(int32(floor(Nf/2)):int32(floor(Nf/2)+2),int32(floor(Nf/2)):int32(floor(Nf/2)+2)) = 0;
eps = 0.001;

for r = 1:Nr,
    for c = 1:Nc,
        ind = ind + 1;
        res(:,:,ind) = x((r-1)*N+S1:r*N-S2,(c-1)*N+S1:c*N-S2);
        res(:,:,ind) = res(:,:,ind).*mask; 
        res(:,:,ind) = res(:,:,ind) - (sum2(res(:,:,ind))/(Nf*Nf-9) );
        res(:,:,ind) = res(:,:,ind).*mask; 
        res(:,:,ind) = res(:,:,ind) / (sqrt(sum2(res(:,:,ind).*res(:,:,ind))) + eps);
    end
end

X = reshape(res, Nf*Nf, temps);
mid = int32( floor(Nf/2)*Nf + floor(Nf/2) + 1 );
coeff = pca(X);
Xtr = X*coeff;

Xpc1 = reshape([Xtr(1:mid-1,1);Xtr(mid:end,1)],Nf,Nf);
Xpc2 = reshape([Xtr(1:mid-1,2);Xtr(mid:end,2)],Nf,Nf);
Xpc3 = reshape([Xtr(1:mid-1,3);Xtr(mid:end,3)],Nf,Nf);


